#
# Conditional build:
%bcond_without	tests	# unit tests

%define	module gunicorn
Summary:	Python WSGI application server
Summary(pl.UTF-8):	Pythonowy serwer aplikacji WSGI
Name:		python3-%{module}
Version:	23.0.0
Release:	1
License:	MIT
Group:		Daemons
#Source0Download: https://pypi.org/simple/gunicorn/
Source0:	https://files.pythonhosted.org/packages/source/g/gunicorn/%{module}-%{version}.tar.gz
# Source0-md5:	18b666db62a890579170639961c5b064
# distro-specific, not upstreamable
Patch100:	%{name}-dev-log.patch
URL:		https://gunicorn.org/
BuildRequires:	python3-devel >= 1:3.5
BuildRequires:	python3-build
BuildRequires:	python3-installer
%if %{with tests}
BuildRequires:	python3-aiohttp
BuildRequires:	python3-coverage >= 4.0
BuildRequires:	python3-eventlet >= 0.24.1
BuildRequires:	python3-gevent >= 1.4.0
BuildRequires:	python3-pytest >= 3.2.5
BuildRequires:	python3-pytest-cov >= 2.5.1
%endif
BuildRequires:	rpm-pythonprov
BuildRequires:	rpmbuild(macros) >= 1.714
BuildRequires:	sed >= 4.0
%if %{with doc}
BuildRequires:	sphinx-pdg-3
BuildRequires:	python3-sphinx_rtd_theme
%endif
Requires:	python3-setuptools
BuildArch:	noarch
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
Gunicorn ("Green Unicorn") is a Python WSGI HTTP server for UNIX. It
uses the pre-fork worker model, ported from Ruby's Unicorn project. It
supports WSGI, Django, and Paster applications.

%description -l pl.UTF-8
Gunicorn ("Green Unicorn" - zielony jednorożec) to pythonowy serwer
HTTP WSGI dla systemów uniksowych. Wykorzystuje model pre-fork,
przeniesiony z projektu Unicorn napisanego w języku Ruby. Obsługuje
aplikacje WSGI, Django i Paster.

%prep
%setup -q -n %{module}-%{version}
%patch -P 100 -p1

%build
%py3_build_pyproject

%if %{with tests}
%{__python3} -m zipfile -e build-3/*.whl build-3-test
# use explicit plugins list for reliable builds (delete PYTEST_PLUGINS if empty)
PYTEST_DISABLE_PLUGIN_AUTOLOAD=1 \
PYTEST_PLUGINS="pytest_cov.plugin" \
%{__python3} -m pytest -o pythonpath="$PWD/build-3-test" tests
%endif

%install
rm -rf $RPM_BUILD_ROOT

%py3_install_pyproject

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(644,root,root,755)
%doc LICENSE NOTICE README.rst THANKS
%attr(755,root,root) %{_bindir}/gunicorn
%{py3_sitescriptdir}/gunicorn
%{py3_sitescriptdir}/gunicorn-%{version}.dist-info
%changelog
* Sat Apr 26 2025 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/python3-gunicorn.git;a=log;h=master

* Sun Apr 27 2025 Jan Rękorajski <baggins@pld-linux.org> 2b93e3b
- up to 23.0.0

* Tue Mar 11 2025 Jan Rękorajski <baggins@pld-linux.org> da5da8c
- doc/test rebuild for python 3.13

* Mon Mar 10 2025 Jan Rękorajski <baggins@pld-linux.org> 056004c
- python 3.13 rebuild

* Sun Mar 09 2025 Jan Rękorajski <baggins@pld-linux.org> 6dcd6db
- use patch -P

* Mon Oct 24 2022 Jakub Bogusz <qboosh@pld-linux.org> 6ea6c23
- updated download URL

* Wed Mar 30 2022 Jan Rękorajski <baggins@pld-linux.org> 5138a99
- rebuild with tests and docs

* Fri Mar 25 2022 Jan Rękorajski <baggins@pld-linux.org> e6419b9
- rebuild with python 3.10

* Thu Mar 24 2022 Jakub Bogusz <qboosh@pld-linux.org> 1e7abfc
- fix for eventlet 0.30+ changes from git

* Thu Mar 24 2022 Jakub Bogusz <qboosh@pld-linux.org> bd2c4c6
- updated to 20.1.0
- added eventlet0.30 patch (adjust for eventlet 0.30+ changes)

* Thu Dec 16 2021 Jakub Bogusz <qboosh@pld-linux.org> 8500b22
- setuptools epoch

* Sat Feb 27 2021 Jan Rękorajski <baggins@pld-linux.org> e8a4a0e
- release 2 (by relup.sh)

* Sun Feb 07 2021 Jakub Bogusz <qboosh@pld-linux.org> 3760dd3
- python-gunicorn.spec updated to 20.0.4 (for python 3.5+) as python3-gunicorn.spec

* Sat Feb 06 2021 Jakub Bogusz <qboosh@pld-linux.org> 789c1f1
- updated to 19.10.0

* Mon Nov 04 2019 Jan Rękorajski <baggins@pld-linux.org> cd6129a
- up to 19.9.0

* Mon Oct 28 2019 Jan Rękorajski <baggins@pld-linux.org> e7951e8
- rebuild with python 3.8
- release 3 (by relup.sh)

* Tue Jul 03 2018 Arkadiusz Miśkiewicz <arekm@maven.pl> 716e002
- release 2 (by relup.sh)

* Fri Mar 17 2017 Jakub Bogusz <qboosh@pld-linux.org> 872f837
- updated to 19.7.0; builds in a sane way now

* Thu Dec 29 2016 Arkadiusz Miśkiewicz <arekm@maven.pl> fffd1fd
- python 3.6
- release 5 (by relup.sh)

* Sun Nov 29 2015 Jacek Konieczny <jajcus@jajcus.net> 93e1679
- BR: rpmbuild(macros) >= 1.710

* Sat Nov 28 2015 Jacek Konieczny <jajcus@jajcus.net> 364231e
- release 4 (by relup.sh)

